-- Dada-Modding --

AnimEssieux = {};

function AnimEssieux.prerequisitesPresent(specializations)
      return true;
end;
function AnimEssieux.initSpecialization()
end
function AnimEssieux.registerOverwrittenFunctions(vehicleType)
end
function AnimEssieux.registerFunctions(vehicleType)	
end
function AnimEssieux.registerEvents(vehicleType)
end
function AnimEssieux:registerActionEventsPlayer()
end
function AnimEssieux:registerActionEventsMenu()
end

function AnimEssieux:onRegisterActionEvents(isSelected, isOnActiveVehicle)
	if isOnActiveVehicle then
		if self.AnimEssieux == nil then 
			self.AnimEssieux = {}
		else	
			self:clearActionEventsTable( self.AnimEssieux )
		end 
		for _,actionName in pairs({"Essieux_AR"}) do
			local _, eventName = self:addActionEvent(self.AnimEssieux, InputAction[actionName], self, AnimEssieux.actionCallback, true, true, false, true, nil);
	
			if isSelected then
				g_inputBinding.events[eventName].displayPriority = 1
			end
		end
	end
end

function AnimEssieux.registerEventListeners(vehicleType)
	SpecializationUtil.registerEventListener(vehicleType, "onLoad", AnimEssieux)
	SpecializationUtil.registerEventListener(vehicleType, "onDelete", AnimEssieux)
    SpecializationUtil.registerEventListener(vehicleType, "onReadStream", AnimEssieux)
    SpecializationUtil.registerEventListener(vehicleType, "onWriteStream", AnimEssieux)
    --SpecializationUtil.registerEventListener(vehicleType, "onReadUpdateStream", AnimEssieux)
    --SpecializationUtil.registerEventListener(vehicleType, "onWriteUpdateStream", AnimEssieux)
	SpecializationUtil.registerEventListener(vehicleType, "onUpdate", AnimEssieux)
	SpecializationUtil.registerEventListener(vehicleType, "onDeactivate", AnimEssieux)
	SpecializationUtil.registerEventListener(vehicleType, "onDraw", AnimEssieux)
	SpecializationUtil.registerEventListener(vehicleType, "onRegisterActionEvents", AnimEssieux)
end

function AnimEssieux:onLoad(vehicle)	
	self.Essieux_AR = AnimEssieux.Essieux_AR
	self.EssieuxAR = false
end;

function AnimEssieux:onDelete() 
end;
function AnimEssieux:onReadStream(streamId, connection)   
end;  
function AnimEssieux:onWriteStream(streamId, connection)  
end;
function AnimEssieux:mouseEvent(posX, posY, isDown, isUp, button)
end;
function AnimEssieux:keyEvent(unicode, sym, modifier, isDown)    
end;
function AnimEssieux:onUpdate(dt, vehicle)		
end;
function AnimEssieux:onUpdateTick() 
end;	
function AnimEssieux:onDeactivate()	
end;       
function AnimEssieux:onDraw()  
end;

function AnimEssieux:actionCallback(actionName, keyStatus, arg4, arg5, arg6)
	if keyStatus > 0 then
		if actionName == 'Essieux_AR' then
			if self.EssieuxAR then
				self:Essieux_AR(false)
			else 
				self:Essieux_AR(true)
			end
		end
	end
end


function AnimEssieux:Essieux_AR(EssieuxAR, noEventSend)
	Essieux_AREvent.sendEvent(self, EssieuxAR, noEventSend)
	self.EssieuxAR = EssieuxAR;
		if self.EssieuxAR then
			for name,_ in pairs(self.spec_animatedVehicle.animations) do
				self:playAnimation("Essieux_AR", 1, nil, true)
			end
		else
			for name,_ in pairs(self.spec_animatedVehicle.animations) do
				self:playAnimation("Essieux_AR", -1, nil, true)
			end
		end;
end;

--- Event ---

Essieux_AREvent = {};
Essieux_AREvent_mt = Class(Essieux_AREvent, Event);
InitEventClass(Essieux_AREvent, "Essieux_AREvent");

function Essieux_AREvent:emptyNew()
    local self = Event:new(Essieux_AREvent_mt);
    return self;
end;
function Essieux_AREvent:new(object, EssieuxAR)
	local self = Essieux_AREvent:emptyNew()
	self.object = object;
	self.EssieuxAR = EssieuxAR;
	return self;
end;
function Essieux_AREvent:readStream(streamId, connection)
	self.object = NetworkUtil.readNodeObject(streamId);
	self.EssieuxAR = streamReadBool(streamId);
	self:run(connection);
end;
function Essieux_AREvent:writeStream(streamId, connection)
	NetworkUtil.writeNodeObject(streamId, self.object);
	streamWriteBool(streamId, self.EssieuxAR);
end;
function Essieux_AREvent:run(connection)
	if not connection:getIsServer() then
		g_server:broadcastEvent(self, false, connection, self.object);
	end;
	if self.object ~= nil then
		self.object:Essieux_AR(self.EssieuxAR, true);
	end;
end;
function Essieux_AREvent.sendEvent(vehicle, EssieuxAR, noEventSend)
	if EssieuxAR ~= vehicle.EssieuxAR then
		if noEventSend == nil or noEventSend == false then
			if g_server ~= nil then
				g_server:broadcastEvent(Essieux_AREvent:new(vehicle, EssieuxAR), nil, nil, vehicle);
			else
				g_client:getServerConnection():sendEvent(Essieux_AREvent:new(vehicle, EssieuxAR));
			end;
		end;
	end;
end;