-- Dada-Modding --

AnimPorte = {};

function AnimPorte.prerequisitesPresent(specializations)
      return true;
end;
function AnimPorte.initSpecialization()
end
function AnimPorte.registerOverwrittenFunctions(vehicleType)
end
function AnimPorte.registerFunctions(vehicleType)	
end
function AnimPorte.registerEvents(vehicleType)
end
function AnimPorte:registerActionEventsPlayer()
end
function AnimPorte:registerActionEventsMenu()
end

function AnimPorte:onRegisterActionEvents(isSelected, isOnActiveVehicle)
	if isOnActiveVehicle then
		if self.AnimPorte == nil then 
			self.AnimPorte = {}
		else	
			self:clearActionEventsTable( self.AnimPorte )
		end 
		for _,actionName in pairs({"Porte_G","Porte_D"}) do
			local _, eventName = self:addActionEvent(self.AnimPorte, InputAction[actionName], self, AnimPorte.actionCallback, true, true, false, true, nil);
	
			if isSelected then
				g_inputBinding.events[eventName].displayPriority = 1
			end
		end
	end
end

function AnimPorte.registerEventListeners(vehicleType)
	SpecializationUtil.registerEventListener(vehicleType, "onLoad", AnimPorte)
	SpecializationUtil.registerEventListener(vehicleType, "onDelete", AnimPorte)
    SpecializationUtil.registerEventListener(vehicleType, "onReadStream", AnimPorte)
    SpecializationUtil.registerEventListener(vehicleType, "onWriteStream", AnimPorte)
    --SpecializationUtil.registerEventListener(vehicleType, "onReadUpdateStream", AnimPorte)
    --SpecializationUtil.registerEventListener(vehicleType, "onWriteUpdateStream", AnimPorte)
	SpecializationUtil.registerEventListener(vehicleType, "onUpdate", AnimPorte)
	SpecializationUtil.registerEventListener(vehicleType, "onDeactivate", AnimPorte)
	SpecializationUtil.registerEventListener(vehicleType, "onDraw", AnimPorte)
	SpecializationUtil.registerEventListener(vehicleType, "onRegisterActionEvents", AnimPorte)
end

function AnimPorte:onLoad(vehicle)	
	self.Porte_G = AnimPorte.Porte_G
	self.Porte_D = AnimPorte.Porte_D
	self.PorteG = false
	self.PorteD = false
	
end;

function AnimPorte:onDelete() 
end;
function AnimPorte:onReadStream(streamId, connection)   
end;  
function AnimPorte:onWriteStream(streamId, connection)  
end;
function AnimPorte:mouseEvent(posX, posY, isDown, isUp, button)
end;
function AnimPorte:keyEvent(unicode, sym, modifier, isDown)    
end;
function AnimPorte:onUpdate(dt, vehicle)		
end;
function AnimPorte:onUpdateTick() 
end;	
function AnimPorte:onDeactivate()	
end;       
function AnimPorte:onDraw()  
end;

function AnimPorte:actionCallback(actionName, keyStatus, arg4, arg5, arg6)
	if keyStatus > 0 then
		if actionName == 'Porte_G' then
			if self.PorteG then
				self:Porte_G(false)
			else 
				self:Porte_G(true)
			end
		end
		if actionName == 'Porte_D' then
			if self.PorteD then
				self:Porte_D(false)
			else 
				self:Porte_D(true)
			end
		end
	end
end


function AnimPorte:Porte_G(PorteG, noEventSend)
	Porte_GEvent.sendEvent(self, PorteG, noEventSend)
	self.PorteG = PorteG;
		if self.PorteG then
			for name,_ in pairs(self.spec_animatedVehicle.animations) do
				self:playAnimation("Porte_G", 1, nil, true)
			end
		else
			for name,_ in pairs(self.spec_animatedVehicle.animations) do
				self:playAnimation("Porte_G", -1, nil, true)
			end
		end;
end;

function AnimPorte:Porte_D(PorteD, noEventSend)
	Porte_DEvent.sendEvent(self, PorteD, noEventSend)
	self.PorteD = PorteD;
		if self.PorteD then
			for name,_ in pairs(self.spec_animatedVehicle.animations) do
				self:playAnimation("Porte_D", 1, nil, true)
			end
		else
			for name,_ in pairs(self.spec_animatedVehicle.animations) do
				self:playAnimation("Porte_D", -1, nil, true)
			end
		end;
end;

--- Event ---

Porte_GEvent = {};
Porte_GEvent_mt = Class(Porte_GEvent, Event);
InitEventClass(Porte_GEvent, "Porte_GEvent");

function Porte_GEvent:emptyNew()
    local self = Event:new(Porte_GEvent_mt);
    return self;
end;
function Porte_GEvent:new(object, PorteG)
	local self = Porte_GEvent:emptyNew()
	self.object = object;
	self.PorteG = PorteG;
	return self;
end;
function Porte_GEvent:readStream(streamId, connection)
	self.object = NetworkUtil.readNodeObject(streamId);
	self.PorteG = streamReadBool(streamId);
	self:run(connection);
end;
function Porte_GEvent:writeStream(streamId, connection)
	NetworkUtil.writeNodeObject(streamId, self.object);
	streamWriteBool(streamId, self.PorteG);
end;
function Porte_GEvent:run(connection)
	if not connection:getIsServer() then
		g_server:broadcastEvent(self, false, connection, self.object);
	end;
	if self.object ~= nil then
		self.object:Porte_G(self.PorteG, true);
	end;
end;
function Porte_GEvent.sendEvent(vehicle, PorteG, noEventSend)
	if PorteG ~= vehicle.PorteG then
		if noEventSend == nil or noEventSend == false then
			if g_server ~= nil then
				g_server:broadcastEvent(Porte_GEvent:new(vehicle, PorteG), nil, nil, vehicle);
			else
				g_client:getServerConnection():sendEvent(Porte_GEvent:new(vehicle, PorteG));
			end;
		end;
	end;
end;


Porte_DEvent = {};
Porte_DEvent_mt = Class(Porte_DEvent, Event);
InitEventClass(Porte_DEvent, "Porte_DEvent");

function Porte_DEvent:emptyNew()
    local self = Event:new(Porte_DEvent_mt);
    return self;
end;
function Porte_DEvent:new(object, PorteD)
	local self = Porte_DEvent:emptyNew()
	self.object = object;
	self.PorteD = PorteD;
	return self;
end;
function Porte_DEvent:readStream(streamId, connection)
	self.object = NetworkUtil.readNodeObject(streamId);
	self.PorteD = streamReadBool(streamId);
	self:run(connection);
end;
function Porte_DEvent:writeStream(streamId, connection)
	NetworkUtil.writeNodeObject(streamId, self.object);
	streamWriteBool(streamId, self.PorteD);
end;
function Porte_DEvent:run(connection)
	if not connection:getIsServer() then
		g_server:broadcastEvent(self, false, connection, self.object);
	end;
	if self.object ~= nil then
		self.object:Porte_D(self.PorteD, true);
	end;
end;
function Porte_DEvent.sendEvent(vehicle, PorteD, noEventSend)
	if PorteD ~= vehicle.PorteD then
		if noEventSend == nil or noEventSend == false then
			if g_server ~= nil then
				g_server:broadcastEvent(Porte_DEvent:new(vehicle, PorteD), nil, nil, vehicle);
			else
				g_client:getServerConnection():sendEvent(Porte_DEvent:new(vehicle, PorteD));
			end;
		end;
	end;
end;